<?xml version="1.0" encoding="latin1" ?>
<!DOCTYPE erlref SYSTEM "erlref.dtd">

<erlref>
  <header>
    <copyright>
      <year>1996</year><year>2009</year>
      <holder>Ericsson AB. All Rights Reserved.</holder>
    </copyright>
    <legalnotice>
      The contents of this file are subject to the Erlang Public License,
      Version 1.1, (the "License"); you may not use this file except in
      compliance with the License. You should have received a copy of the
      Erlang Public License along with this software. If not, it can be
      retrieved online at http://www.erlang.org/.
    
      Software distributed under the License is distributed on an "AS IS"
      basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
      the License for the specific language governing rights and limitations
      under the License.
    
    </legalnotice>

    <title>lib</title>
    <prepared></prepared>
    <docno></docno>
    <date></date>
    <rev></rev>
  </header>
  <module>lib</module>
  <modulesummary>A number of useful library functions</modulesummary>
  <description>
    <warning>
      <p>This module is retained for compatibility. It may disappear
        without warning in a future release.</p>
    </warning>
  </description>
  <funcs>
    <func>
      <name>flush_receive() -> void()</name>
      <fsummary>Flush messages</fsummary>
      <desc>
        <p>Flushes the message buffer of the current process.</p>
      </desc>
    </func>
    <func>
      <name>error_message(Format, Args) -> ok</name>
      <fsummary>Print error message</fsummary>
      <type>
        <v>Format = atom() | string() | binary()</v>
        <v>Args = [term()]</v>
      </type>
      <desc>
        <p>Prints error message <c>Args</c> in accordance with
          <c>Format</c>. Similar to <c>io:format/2</c>, see
          <seealso marker="io#fwrite/1">io(3)</seealso>.</p>
      </desc>
    </func>
    <func>
      <name>progname() -> atom()</name>
      <fsummary>Return name of Erlang start script</fsummary>
      <desc>
        <p>Returns the name of the script that started the current
          Erlang session.</p>
      </desc>
    </func>
    <func>
      <name>nonl(String1) -> String2</name>
      <fsummary>Remove last newline</fsummary>
      <type>
        <v>String1 = String2 = string()</v>
      </type>
      <desc>
        <p>Removes the last newline character, if any, in
          <c>String1</c>.</p>
      </desc>
    </func>
    <func>
      <name>send(To, Msg)</name>
      <fsummary>Send a message</fsummary>
      <type>
        <v>To = pid() | Name | {Name,Node}</v>
        <v>&nbsp;Name = Node = atom()</v>
        <v>Msg = term()</v>
      </type>
      <desc>
        <p>This function to makes it possible to send a message using
          the <c>apply/3</c> BIF.</p>
      </desc>
    </func>
    <func>
      <name>sendw(To, Msg)</name>
      <fsummary>Send a message and wait for an answer</fsummary>
      <type>
        <v>To = pid() | Name | {Name,Node}</v>
        <v>&nbsp;Name = Node = atom()</v>
        <v>Msg = term()</v>
      </type>
      <desc>
        <p>As <c>send/2</c>, but waits for an answer. It is implemented
          as follows:</p>
        <code type="none">
sendw(To, Msg) ->
    To ! {self(),Msg},
    receive
        Reply -> Reply
    end.</code>
        <p>The message returned is not necessarily a reply to the
          message sent.</p>
      </desc>
    </func>
  </funcs>
</erlref>

